#ifndef G58D7ADAC31B641BBB2792BEA482E62DC
#define G58D7ADAC31B641BBB2792BEA482E62DC

#include <array>
#include <optional>
#include <string>
#include <type_traits>

enum class Season : int
{
    spring = 0,
    summer = 1,
    autumn = 2,
    winter = 3,
};

namespace SeasonEnum
{
using UnderlyingType = std::underlying_type_t<Season>;

constexpr const std::size_t enumerator_count = 4;
constexpr const bool is_bitflags_enum = false;
constexpr const bool has_consecutive_enumerators = true;
constexpr const bool starts_at_zero = true;

UnderlyingType to_underlying_type(Season s) noexcept;
std::optional<Season> from_underlying_type(UnderlyingType i) noexcept;
Season from_underlying_type(UnderlyingType i, Season fallback) noexcept;
bool is_convertible_from(UnderlyingType i) noexcept;

std::string to_string(Season s);
std::optional<Season> from_string(const std::string& str) noexcept;
Season from_string(const std::string& str, Season fallback) noexcept;
bool is_convertible_from(const std::string& str) noexcept;

constexpr std::array<Season, enumerator_count> enumerators{
        Season::spring, Season::summer, Season::autumn, Season::winter};
}  // namespace SeasonEnum

#endif
