#ifndef ED4DFC5EA1B04193B26C7D2AD84AEA79
#define ED4DFC5EA1B04193B26C7D2AD84AEA79

#include "enum_extensions.hpp"
#include <array>
#include <type_traits>

enum class Season : int
{
    spring = 0,
    summer = 1,
    autumn = 2,
    winter = 3,
};

template<>
struct EnumExt<Season>
    : enum_ext::Conversion<EnumExt<Season>, Season>
    , enum_ext::IterationTag
{
    using EnumType = Season;
    using UnderlyingType = std::underlying_type_t<Season>;

    constexpr static const std::size_t enumerator_count = 4;
    constexpr static const bool is_bitflags_enum = false;
    constexpr static const bool has_consecutive_enumerators = true;
    constexpr static const bool starts_at_zero = true;

    static std::optional<Season> from_underlying_type(UnderlyingType i) noexcept;

    static std::string to_string(Season s);
    static std::optional<Season> from_string(const std::string& str) noexcept;

    constexpr static const std::array<Season, enumerator_count> enumerators{
            Season::spring,
            Season::summer,
            Season::autumn,
            Season::winter,
    };
};

using SeasonEnum = EnumExt<Season>;

#endif
